local bar = _G[...]
local modName = ...
local title = "Health"
--Health Bar
local component = bar:GetTemplate("StatusBar", title)

function component:New(parent)
	return self:Bind(self:CreateNew(parent, title))
end


function component:OnUpdate()
	local unit = self.owner.id
	local dead = UnitIsGhost(unit) or UnitIsDead(unit)
	local deadText
	if dead then
		deadText = "Dead"
	end
	
	
	self:SetValues(UnitHealth(unit), 0, UnitHealthMax(unit), dead, deadText)
	
	local r, g, b
	if not UnitIsConnected(unit) then
		r, g, b = .5, .5, .5
	else
		if self.sets.classColor then
			local localizedClass, englishClass = UnitClass(unit)
			local classColor = RAID_CLASS_COLORS[englishClass]
			if ( classColor ) then
				r, g, b = classColor.r, classColor.g, classColor.b
			else

			end
		else
			if ( UnitIsFriend('player', unit) ) then
				r, g, b = 0.0, 1.0, 0.0
			else
				r, g, b = 1.0, 0.0, 0.0
			end
		end
	end
	if dead then
		r, g, b = r-.75, g-.75, b-.75
	end
	
	self:SetColor(r, g, b, 1)
end

component.options = {
                    {
                        name = 'Class Colored',
                        kind = 'CheckButton',
                        key = 'classColor',
						panel = "texture",
                    },
                    {
                        name = 'Texture',
                        kind = 'Media',
                        key = 'textureName',
                        mediaType = 'StatusBar',
                        handler = string.lower(title),
						panel = "texture",
                    },
}