
PowerBarColor = {};
PowerBarColor["MANA"] = { r = 0.00, g = 0.00, b = 1.00 };
PowerBarColor["RAGE"] = { r = 1.00, g = 0.00, b = 0.00, fullPowerAnim=true };
PowerBarColor["FOCUS"] = { r = 1.00, g = 0.50, b = 0.25, fullPowerAnim=true };
PowerBarColor["ENERGY"] = { r = 1.00, g = 1.00, b = 0.00, fullPowerAnim=true };
PowerBarColor["COMBO_POINTS"] = { r = 1.00, g = 0.96, b = 0.41 };
PowerBarColor["RUNES"] = { r = 0.50, g = 0.50, b = 0.50 };
PowerBarColor["RUNIC_POWER"] = { r = 0.00, g = 0.82, b = 1.00 };
PowerBarColor["SOUL_SHARDS"] = { r = 0.50, g = 0.32, b = 0.55 };
PowerBarColor["LUNAR_POWER"] = { r = 0.30, g = 0.52, b = 0.90, atlas="_Druid-LunarBar" };
PowerBarColor["HOLY_POWER"] = { r = 0.95, g = 0.90, b = 0.60 };
PowerBarColor["MAELSTROM"] = { r = 0.00, g = 0.50, b = 1.00, atlas = "_Shaman-MaelstromBar", fullPowerAnim=true };
PowerBarColor["INSANITY"] = { r = 0.40, g = 0, b = 0.80, atlas = "_Priest-InsanityBar"};
PowerBarColor["CHI"] = { r = 0.71, g = 1.0, b = 0.92 };
PowerBarColor["ARCANE_CHARGES"] = { r = 0.1, g = 0.1, b = 0.98 };
PowerBarColor["FURY"] = { r = 0.788, g = 0.259, b = 0.992, atlas = "_DemonHunter-DemonicFuryBar", fullPowerAnim=true };
PowerBarColor["PAIN"] = { r = 255/255, g = 156/255, b = 0, atlas = "_DemonHunter-DemonicPainBar", fullPowerAnim=true };
-- vehicle colors
PowerBarColor["AMMOSLOT"] = { r = 0.80, g = 0.60, b = 0.00 };
PowerBarColor["FUEL"] = { r = 0.0, g = 0.55, b = 0.5 };
PowerBarColor["STAGGER"] = { {r = 0.52, g = 1.0, b = 0.52}, {r = 1.0, g = 0.98, b = 0.72}, {r = 1.0, g = 0.42, b = 0.42},};

-- these are mostly needed for a fallback case (in case the code tries to index a power token that is missing from the table,
-- it will try to index by power type instead)
PowerBarColor[0] = PowerBarColor["MANA"];
PowerBarColor[1] = PowerBarColor["RAGE"];
PowerBarColor[2] = PowerBarColor["FOCUS"];
PowerBarColor[3] = PowerBarColor["ENERGY"];
PowerBarColor[4] = PowerBarColor["CHI"];
PowerBarColor[5] = PowerBarColor["RUNES"];
PowerBarColor[6] = PowerBarColor["RUNIC_POWER"];
PowerBarColor[7] = PowerBarColor["SOUL_SHARDS"];
PowerBarColor[8] = PowerBarColor["LUNAR_POWER"];
PowerBarColor[9] = PowerBarColor["HOLY_POWER"];
PowerBarColor[11] = PowerBarColor["MAELSTROM"];
PowerBarColor[13] = PowerBarColor["INSANITY"];
PowerBarColor[17] = PowerBarColor["FURY"];
PowerBarColor[18] = PowerBarColor["PAIN"];


local bar = _G[...]
local modName = ...
local title = "Power"
--Power Bar
local component = bar:GetTemplate("StatusBar", title)

function component:New(parent)
	local comp = self:Bind(self:CreateNew(parent, title))

	return comp
end

local basePower = {
        [0] = {
            ["Druid"] = true,
            ["Warlock"] = true,
            ["Shaman"] = true,
            ["Mage"] = true,
            ["Monk"] = true,
            ["Paladin"] = true,
            ["Priest"] = true,
        },
        [1] = {
            ["Warrior"] = true
        },
        [6] = {
            ["Death Knight"] = true
        },
        [3] = {
            ["Rogue"] = true
        }
}


function component:UpdateType()

		local unit = self.owner.id

	local powerType, powerToken, altR, altG, altB = UnitPowerType(unit);
	local prefix = _G[powerToken];
	local info = PowerBarColor[powerToken];
	if ( info ) then
		if ( not self.lockColor ) then
			local playerDeadOrGhost = (unit == "player" and (UnitIsDead("player") or UnitIsGhost("player")));
			if ( info.atlas ) then
				self:SetStatusBarAtlas(info.atlas);
				self:SetStatusBarColor(1, 1, 1);
				self:SetColor(1,1,1, 1)
				self:GetStatusBarTexture():SetDesaturated(playerDeadOrGhost);
				self:GetStatusBarTexture():SetAlpha(playerDeadOrGhost and 0.5 or 1);
			else
				self:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
				if ( playerDeadOrGhost ) then
					self:SetColor(0.6, 0.6, 0.6, 0.5)
				else
					self:SetColor(info.r, info.g, info.b, 1)
				end
			end

			if ( self.FeedbackFrame ) then
				self.FeedbackFrame:Initialize(info, unit, powerType);
			end

			if ( self.FullPowerFrame ) then
				self.FullPowerFrame:Initialize(info.fullPowerAnim);
			end
		end
	else
		if ( not altR) then
			-- couldn't find a power token entry...default to indexing by power type or just mana if we don't have that either
			info = PowerBarColor[powerType] or PowerBarColor["MANA"];
		else
			if ( not self.lockColor ) then
				self:SetColor(altR, altG, altB, 1)
			end
		end
	end
	if ( self.powerType ~= powerType or self.powerType ~= powerType ) then
		self.powerType = powerType;
		self.powerToken = powerToken;
		if ( self.FullPowerFrame ) then
		--	self.FullPowerFrame:RemoveAnims();
		end
		--self.currValue = UnitPower("player", powerType);
	end

	-- Update the manabar text
	if ( not self.noTextPrefix ) then
	--	SetTextStatusBarTextPrefix(self, prefix);
	end
	--TextStatusBar_UpdateTextString(self);
end

function component:OnUpdate()
	local unit = self.owner.id
	
	local basePower_index = basePower[UnitClass(unit)]
	local max = UnitPowerMax(unit)
	local current = UnitPower(unit)
	

	
	if UnitPowerType(unit) and basePower[UnitPowerType(unit)] and basePower[UnitPowerType(unit)][UnitClass(unit)] then
	    max = 0
	end
	
	local dead = UnitIsGhost(unit) or UnitIsDead(unit)

	
	
	
	self:SetValues(current, 0, max, dead)
	--[[
	local r, g, b
	if ( not UnitIsConnected(unit)) then
		r, g, b = 0.5, 0.5, 0.5
	else
		local powerType, powerToken, altR, altG, altB = UnitPowerType(unit, basePower_index)
		powerType = basePower_index
		local info = PowerBarColor[powerToken]
		if ( info ) then
			r, g, b = info.r, info.g, info.b
		else
			if ( not altR) then
				info = PowerBarColor[powerType] or PowerBarColor['MANA']
				r, g, b = info.r, info.g, info.b
			else
				r, g, b = altR, altG, altB
			end
		end
	end
	if dead then
		r, g, b = r-.75, g-.75, b-.75
	end
	
	self:SetColor(r, g, b, 1)
	--]]
	self:UpdateType()
	
end

component.options = {
                    {
                        name = 'Texture',
                        kind = 'Media',
                        key = 'textureName',
                        mediaType = 'StatusBar',
                        handler = string.lower(title),
						panel = "texture",
                    },
}
