local bar = _G[...]

local templates = {virtual = {}}
bar.templates = templates


function bar:NewTemplate(name)
	templates.virtual[name] = {}
	return templates.virtual[name]
end


local function Merge(source, destination)
	if not destination then
		destination = {}
	end
	if not source then
		return destination
	end
	for i, b in pairs(source) do
		if (type(b) == 'table') then
			destination[i] = Merge(b, destination[i])
		else
			destination[i] = b
		end
	end
	return destination
end

bar.Merge = Merge

function bar:GetTemplate(template, name)
	local temp = templates.virtual[template]
	if temp then
		return Merge(CopyTable(templates.virtual[template]), bar:NewComponent(string.lower(name), template))
	else
		print("Template does not exsist: "..template)
	end
end